"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.usePageLoader = exports.NProgressStyleCreator = void 0;
var tslib_1 = require("tslib");
var react_1 = require("react");
var router_1 = tslib_1.__importDefault(require("next/router"));
var nprogress_1 = tslib_1.__importDefault(require("nprogress"));
var styled_components_1 = require("styled-components");
var NProgressStyleCreator = function (color) { return styled_components_1.createGlobalStyle(templateObject_1 || (templateObject_1 = tslib_1.__makeTemplateObject(["\n/* Make clicks pass-through */\n#nprogress {\n  pointer-events: none;\n}\n\n#nprogress .bar {\n  background: ", ";\n  position: fixed;\n  z-index: 9999;\n  top: 0;\n  left: 0;\n  width: 100%;\n  height: 2px;\n}\n\n#nprogress .peg {\n  display: block;\n  position: absolute;\n  right: 0px;\n  width: 100px;\n  height: 100%;\n  box-shadow: 0 0 10px ", ", 0 0 5px ", ";\n  opacity: 1;\n  -webkit-transform: rotate(3deg) translate(0px, -4px);\n  -ms-transform: rotate(3deg) translate(0px, -4px);\n  transform: rotate(3deg) translate(0px, -4px);\n}\n"], ["\n/* Make clicks pass-through */\n#nprogress {\n  pointer-events: none;\n}\n\n#nprogress .bar {\n  background: ", ";\n  position: fixed;\n  z-index: 9999;\n  top: 0;\n  left: 0;\n  width: 100%;\n  height: 2px;\n}\n\n#nprogress .peg {\n  display: block;\n  position: absolute;\n  right: 0px;\n  width: 100px;\n  height: 100%;\n  box-shadow: 0 0 10px ", ", 0 0 5px ", ";\n  opacity: 1;\n  -webkit-transform: rotate(3deg) translate(0px, -4px);\n  -ms-transform: rotate(3deg) translate(0px, -4px);\n  transform: rotate(3deg) translate(0px, -4px);\n}\n"])), color !== null && color !== void 0 ? color : 'black', color !== null && color !== void 0 ? color : 'black', color !== null && color !== void 0 ? color : 'black'); };
exports.NProgressStyleCreator = NProgressStyleCreator;
var usePageLoader = function (delay) {
    if (delay === void 0) { delay = 200; }
    var _a = react_1.useState(), timer = _a[0], setTimer = _a[1];
    var routeChangeStart = function () {
        window.clearTimeout(timer);
        setTimer(window.setTimeout(nprogress_1.default.start, delay));
    };
    var routeChangeEnd = function () {
        window.clearTimeout(timer);
        nprogress_1.default.done();
    };
    react_1.useEffect(function () {
        router_1.default.events.on('routeChangeStart', routeChangeStart);
        router_1.default.events.on('routeChangeComplete', routeChangeEnd);
        router_1.default.events.on('routeChangeError', routeChangeEnd);
        nprogress_1.default.configure({
            showSpinner: false,
        });
        return function () {
            window.clearTimeout(timer);
            router_1.default.events.off('routeChangeStart', routeChangeStart);
            router_1.default.events.off('routeChangeComplete', routeChangeEnd);
            router_1.default.events.off('routeChangeError', routeChangeEnd);
        };
    });
};
exports.usePageLoader = usePageLoader;
var templateObject_1;
//# sourceMappingURL=index.js.map